SystemOrganization addCategory: #'ObjectIndexer-Core'!
SystemOrganization addCategory: #'ObjectIndexer-Core-Tests'!
SystemOrganization addCategory: #'ObjectIndexer-ScouchDB'!

TestCase subclass: #OIndexerTest
	instanceVariableNames: 'indexer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core-Tests'!

!OIndexerTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/26/2013 11:35'!
getEmptyIndexer
| ob |
"indexe four string object indexed by its value"
indexer := OIndexer on:'objectIndexer-empty-test'.

^indexer
! !

!OIndexerTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/27/2013 17:31'!
getIndexer
| ob |
indexer ifNil:[
	"indexe four string object indexed by its value"
	ob:=Array with:'hello .hello world' with:'hello' with:'are' with:'you'.
	indexer := OIndexer on:'objectIndexer-test'.
	indexer indexeMessages: (Array with:#asString) by: #asString  fromACollection: ob.
	].
^indexer
! !

!OIndexerTest methodsFor: 'tests' stamp: 'JesusMari 2/4/2013 03:39'!
testLongFile
	| oi result ob|
	
	
	oi := self getEmptyIndexer.
	oi indexeMessages: (Array with:'jquerycouchJs') by: 'id' from: OItest new.
	oi indexeMessages: (Array with:'render') by: 'class' from: MustacheTest5 new.
	result:= oi findPhrase:  'name function' minTarget: 3/4.
	self assert:  ((result at:1) key ='jquerycouch') .
! !

!OIndexerTest methodsFor: 'tests' stamp: 'JesusMari 2/4/2013 03:58'!
testLongFile2
	| oi result ob|
	
	
	oi := self getEmptyIndexer.

	result:= oi findPhrase:  'name function' minTarget: 3/4.
	self assert:  ((result at:1) key ='jquerycouch') .
	result:= oi findPhrase:  'object to an url query string' minTarget: 3/4.
	self assert:  ((result at:1) key ='jquerycouch') .! !

!OIndexerTest methodsFor: 'tests' stamp: 'JesusMari 1/29/2013 16:14'!
testVariousResults
	| oi result ob|
	
	
	oi := self getIndexer.
	
	result:= oi findPhrase:  'hello' minTarget: 3/4.

	self assert:  ((result at:1) value = 1.0) .
	self assert:  ((result at:2) value = 1.0) .

	result:= oi findPhrase:  'world hello ' minTarget: 0.5.
	self assert:  ((result at:1) key = 'hello .hello world') .
	self assert:  ((result at:1) value =0.8611111111111112 ) .
	
	result:= oi findPhrase:  'hello world' minTarget: 0.5.
	self assert:  ((result at:1) key = 'hello .hello world') .
	self assert:  ((result at:1) value =1) .

	result:= oi findPhrase:  'hello world Jesus' minTarget: 0.5.
	self assert:  ((result at:1) key = 'hello .hello world') .
	self assert:  ((result at:1) value =0.6666666666666666) .
	

	result:= oi findPhrase:  'hell' minTarget: 1.
	self assert:  ((result at:1) key = 'hello .hello world') .
	self assert:  ((result at:1) value = 1.0) .
	! !

!SCouchDBAppWrapper methodsFor: '*objectIndexer-scouchdb-validate' stamp: 'JesusMari 1/12/2013 13:41'!
indexerAt: anIndexerPath

^self validate indexerAt: (anIndexerPath).! !

!SCouchDBValidate methodsFor: '*objectIndexer-scouchdb' stamp: 'JesusMari 1/21/2013 18:40'!
indexerAt:aRelativePath
|a|
a:= indexers 
ifNil:[
	indexers:= JsonObject new. 
	indexers at:aRelativePath put:(OIndexer on:aRelativePath)
	] 
ifNotNil:[
	indexers at:aRelativePath ifAbsentPut:(OIndexer on:aRelativePath)].

^a! !

Object subclass: #OIIndexNodeFS
	instanceVariableNames: 'identifierCollection fd dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core'!

!OIIndexNodeFS class methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/30/2012 03:22'!
new
|a|
a:=super new.
a initialize.
a fd: (FileDirectory on:( FileDirectory default pathName, FileDirectory pathNameDelimiter asString, a identityHash asString)).
^a 
! !

!OIIndexNodeFS class methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/3/2013 18:32'!
on:aPath
|a|
a:=super new.
a initialize.
a fd: (FileDirectory on:( aPath)).
^a 
! !

!OIIndexNodeFS methodsFor: 'accessing' stamp: 'JesusMari 2/4/2013 02:17'!
addIdentifier: anObject atPos:anInteger word:aWord
	self identifiers	add: (OIResult id:anObject pos:anInteger word:aWord).
	"self snapshot."! !

!OIIndexNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/30/2012 05:19'!
at:anObject
|a|
a:=self class new.
a fd: (self fd on: (self fd directoryEntryFor: anObject asString) fullName).
^a 

! !

!OIIndexNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/30/2012 05:23'!
at:anObject ifAbsent: aBlock
|a subdir|
a:=self class new.
subdir:=(self fd directoryEntryFor: anObject asString).
subdir
ifNil:[aBlock value]
 ifNotNil:[
				a fd: (self fd on:  subdir fullName).
					^a ]

! !

!OIIndexNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/27/2013 17:25'!
at:anObject ifAbsentPut:aNode
| pathName a|
a:=dictionary at:anObject ifAbsent:[
	pathName:=self trulyAssureExistenceOfPath: anObject.
 	aNode fd: (self fd on: pathName).
	dictionary at:anObject put:aNode].
^a

! !

!OIIndexNodeFS methodsFor: 'accessing' stamp: 'JesusMari 12/30/2012 02:17'!
fd
	^ fd! !

!OIIndexNodeFS methodsFor: 'accessing' stamp: 'JesusMari 12/30/2012 02:17'!
fd: anObject
	fd := anObject! !

!OIIndexNodeFS methodsFor: 'accessing' stamp: 'JesusMari 12/30/2012 02:31'!
identifiers
	identifierCollection ifNil:[self startUp].
	identifierCollection ifNil:[identifierCollection:=OrderedCollection new].
	^ identifierCollection! !

!OIIndexNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/27/2013 22:08'!
initDictionary
dictionary:=nil.
dictionary:=Dictionary new.! !

!OIIndexNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/27/2013 17:26'!
initialize
super initialize.
dictionary:=Dictionary new! !

!OIIndexNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/30/2012 03:10'!
load: aString
|stream result |
stream:=ReferenceStream on:(self fd fileNamed: aString).
[
identifierCollection:= stream next]
ensure:[stream close].

! !

!OIIndexNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/27/2013 20:22'!
merge
"merge with the filesystem node"
| files stream result aString idColection |

files:=self fd fileNamesMatching: '*.obj'.
files isEmpty ifFalse: [
	stream:=ReferenceStream on:(self fd fileNamed: files asSortedCollection last).
	[idColection:= stream next]
	ensure:[stream close].
]

! !

!OIIndexNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/26/2013 11:28'!
purge
|files last fCol counter filesCollection |
files:=self fd fileNamesMatching: '*.obj'.

files isEmpty ifFalse:[
	filesCollection:= files asSortedCollection.
	last:= filesCollection last.
	counter:= filesCollection size.
	filesCollection do:[:a |( a=last or:[ counter< OIndexer maxSnapshotFiles] ) 
		ifFalse:[
			self fd deleteFileNamed: a].
			counter:=counter - 1
		] 
	]! !

!OIIndexNodeFS methodsFor: 'accessing' stamp: 'JesusMari 1/6/2013 18:51'!
removeIdentifier: anId

	self identifiers removeAllSuchThat: [:aResult|(aResult id= anId) ].
	self snapshot
	! !

!OIIndexNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/27/2013 22:08'!
snapshot
	|stream|
	(identifierCollection isNil) ifTrue:[^self].
	stream:=ReferenceStream on:(self fd fileNamed: (String streamContents:[:filename|
		Date current
			printOn: filename
			format: #(3 2 1 $- 1 1 2).
		filename space; nextPutAll: (Time current print24
			collect: [:char| char = $: ifTrue:[$-] ifFalse:[char]]).
			filename nextPutAll: '.obj'])).
		[stream nextPut: identifierCollection ] ensure: [
		stream close.
		identifierCollection:= nil.
		self initDictionary.
		]! !

!OIIndexNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/30/2012 03:05'!
startUp
|files|
files:=self fd fileNamesMatching: '*.obj'.
files isEmpty ifFalse: [
	self load: files asSortedCollection last
	]! !

!OIIndexNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/26/2013 18:08'!
trulyAssureExistenceOfPath: anObject
|subdirs sd|
	sd:=self fd.

		subdirs:= anObject asString findTokens: fd pathNameDelimiter.
		subdirs do:[:aDir|
			sd:=sd assureExistenceOfPath: aDir.
			sd:= FileDirectory on: sd pathName, sd pathNameDelimiter asString, aDir.
			].
		^ sd pathName.
! !

!OIIndexNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/30/2012 05:40'!
values
|oc|
oc:=OrderedCollection new.
self fd entries do:[:aDir|
	aDir isDirectory ifTrue:[
		oc add:(self at:aDir name).
		]
	].
^oc
! !

Object subclass: #OIResult
	instanceVariableNames: 'id pos word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core'!

!OIResult class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/4/2013 02:18'!
id:anID pos:pos word:aWord
|i|
i:=  self new.
i id:anID.
i pos:pos.
i word:aWord.
^i
! !

!OIResult methodsFor: 'accessing' stamp: 'JesusMari 12/27/2012 16:04'!
id
	^ id! !

!OIResult methodsFor: 'accessing' stamp: 'JesusMari 12/27/2012 16:04'!
id: anObject
	id := anObject! !

!OIResult methodsFor: 'accessing' stamp: 'JesusMari 12/27/2012 16:04'!
pos
	^ pos! !

!OIResult methodsFor: 'accessing' stamp: 'JesusMari 12/27/2012 16:04'!
pos: anObject
	pos := anObject! !

!OIResult methodsFor: 'accessing' stamp: 'JesusMari 2/4/2013 02:15'!
word
	^ word! !

!OIResult methodsFor: 'accessing' stamp: 'JesusMari 2/4/2013 02:15'!
word: anObject
	word := anObject! !

Object subclass: #OIReverseNodeFS
	instanceVariableNames: 'identifierCollection default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core'!

!OIReverseNodeFS class methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/8/2013 01:46'!
on:aDir
|a|
a:=super new.
a initialize.
FileDirectory  default assureExistenceOfPath: (aDir).
a default: (FileDirectory on:aDir).
^a! !

!OIReverseNodeFS methodsFor: 'accessing' stamp: 'JesusMari 1/3/2013 18:13'!
at:identifier 
^self identifiers at:identifier ifAbsent:[self startUp:identifier].

! !

!OIReverseNodeFS methodsFor: 'accessing' stamp: 'JesusMari 1/25/2013 20:18'!
at:identifier put:aPathToResults
| a |
a:=self at:identifier.
a add:aPathToResults.
! !

!OIReverseNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/4/2013 02:32'!
clean: aWord
^(aWord asString select:[:c | c isLetter or: [c = Character space ]] ) asLowercase ! !

!OIReverseNodeFS methodsFor: 'accessing' stamp: 'JesusMari 1/3/2013 17:19'!
default
	^ default! !

!OIReverseNodeFS methodsFor: 'accessing' stamp: 'JesusMari 1/3/2013 17:19'!
default: anObject
	default := anObject! !

!OIReverseNodeFS methodsFor: 'accessing' stamp: 'JesusMari 1/3/2013 16:37'!
identifiers
	identifierCollection ifNil:[identifierCollection:=Dictionary new].
	^ identifierCollection! !

!OIReverseNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/3/2013 18:16'!
loadAt: id put:aFilename
|stream result collection |
stream:=ReferenceStream on:(self default fileNamed: aFilename).
[
	collection:= stream next.
	^self identifiers at:id put:collection]
ensure:[stream close].

! !

!OIReverseNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/26/2013 11:28'!
purge:id
|files last counter filesCollection|
files:=self default fileNamesMatching: (id,'.*.obj').

files isEmpty ifFalse:[
	filesCollection:= files asSortedCollection.
	last:= filesCollection last.
	counter:= filesCollection size.

	filesCollection do:[:a |( a=last or:[ counter < OIndexer maxSnapshotFiles] ) 
		ifFalse:[
			self default deleteFileNamed: a].
			counter:=counter - 1
		]
]
! !

!OIReverseNodeFS methodsFor: 'accessing' stamp: 'JesusMari 1/8/2013 01:01'!
remove: anId
	"assure an Id is an empty Set it will avoid loading from the disk when we call ... at: or at:put:"
	self identifiers at:anId put:Set new.


	! !

!OIReverseNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/4/2013 03:50'!
snapshot:id
	|stream|
	self identifiers at:id ifAbsentPut:(Set new).
	stream:=ReferenceStream on:(self default  fileNamed: (String streamContents:[:filename|
		filename nextPutAll: ((self clean:id asString ), '.').
		Date current
			printOn: filename
			format: #(3 2 1 $- 1 1 2).
		filename space; nextPutAll: (Time current print24
			collect: [:char| char = $: ifTrue:[$-] ifFalse:[char]]).
			filename nextPutAll: '.obj'])).
		[stream nextPut:( self identifiers at:id) ] ensure: [stream close].
	"once it is saved remove from memory, we do not want it for so long"
	self identifiers removeKey:id.! !

!OIReverseNodeFS methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/29/2013 16:09'!
startUp:id
|files|
files:=self default fileNamesMatching: ((self clean: id) ,'.*.obj').
files isEmpty ifFalse: [
	^self identifiers at:id put:(self loadAt:id put: (files asSortedCollection last))
	].
^self identifiers at:id put:(Set new)! !

Object subclass: #OIndexer
	instanceVariableNames: 'mainIndex reverseIndex indexName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core'!

!OIndexer class methodsFor: 'private' stamp: 'JesusMari 1/26/2013 10:37'!
maxSnapshotFiles
^10! !

!OIndexer class methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/8/2013 01:42'!
new
| a |
a:= super new.
a initialize:nil.
^a! !

!OIndexer class methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/12/2013 17:05'!
on: aDirName
| a |
a:= super new.
a initialize:aDirName.
^a! !

!OIndexer methodsFor: 'private' stamp: 'JesusMari 2/4/2013 02:47'!
clean: aWord
^(aWord collect:[:c | (c isLetter or: [c = Character space ]) ifTrue:[c] ifFalse:[Character space]] ) asLowercase ! !

!OIndexer methodsFor: 'private' stamp: 'JesusMari 12/26/2012 19:08'!
delimiters
^ Character space! !

!OIndexer methodsFor: 'private-querying' stamp: 'JesusMari 1/7/2013 09:18'!
findCandidatesOn:treeNode
^ self findCandidatesOn:treeNode candidates: OrderedCollection new
! !

!OIndexer methodsFor: 'private-querying' stamp: 'JesusMari 1/7/2013 09:18'!
findCandidatesOn:treeNode candidates: c
treeNode identifiers isEmpty
	ifTrue:[
		treeNode values do:[:aTreeNode|
		self findCandidatesOn: aTreeNode candidates: c]
	 ]
	ifFalse: [c addAll: treeNode identifiers ].
	^ c.


! !

!OIndexer methodsFor: 'public-querying' stamp: 'JesusMari 1/22/2013 11:05'!
findPhrase:aPhrase 
self findPhrase:aPhrase minTarget:3/4! !

!OIndexer methodsFor: 'public-querying' stamp: 'JesusMari 2/4/2013 04:01'!
findPhrase:aPhrase minTarget:aFloat
|wordCollection results finalResult aCol lastId lastPos dif counter lastValue multiplier |

finalResult:=Dictionary new.
wordCollection:= ((self clean:(aPhrase asString)) findTokens: self delimiters) select:[:a| a size> self minSize].
results:=OrderedCollection new.
multiplier:=0.
wordCollection do:[:aWord|
	aCol:=(self findWord:aWord minTraget:aFloat).
	aCol isEmpty ifFalse:[multiplier:= multiplier + (1 / wordCollection size)].
	results addAll:aCol .
	].
aCol:=OrderedCollection new.
results:= results sorted:[:k :v| (k id asString<=v id asString) and:[k pos <= v pos]].
self halt.
"results will be an ordered collection of OBResult"
"score by position  1/4"
counter:=0.
results do:[:aResult|
		(aResult id ~= lastId) ifTrue:[
			lastId ifNotNil:[finalResult at: lastId put:
				((finalResult at: lastId ifAbsentPut:0)  / ( counter))].
			lastPos:=0.
			counter:=0].
		finalResult at:(aResult id)put:(
			(( aResult pos) > lastPos) 
			ifTrue:[
				(((counter +1) \\ wordCollection size)=0)
					ifTrue:[dif:=1]
					ifFalse:[dif:= (aResult pos) - lastPos].
				(finalResult at: (aResult id) ifAbsentPut:0) + ( 1 / ( dif  * 4))
				]
			ifFalse:[
				finalResult at: (aResult id) ifAbsentPut:0
				]
			).
			lastId:=(aResult id).
			counter:=counter+1.
			lastPos:=( aResult pos).
		 ].

"the last one"

lastId ifNotNil:[finalResult at: lastId put:
				((finalResult at: lastId ifAbsentPut:0)  / ( counter))].
			
			
"score by value 3/4"
counter:=0.
lastId:=nil.
lastValue:=0.
results do:[:aResult|
	(aResult id ~= lastId) 
		ifTrue:[
			lastId ifNotNil:[
				(counter< wordCollection size) ifTrue:[counter:= wordCollection size].
				finalResult at: lastId put:
				
				((((finalResult at: lastId ifAbsentPut:0)  /  counter)+ lastValue))].
			counter:=0].
		(counter = 0) ifTrue:[
			lastValue:=(finalResult at: (aResult id) ifAbsent:[0]).
			finalResult at: (aResult id) put:0.
			].
		finalResult at:(aResult id)put:((finalResult at: (aResult id) ifAbsentPut:0) + (3 / 4)).
		counter:=counter + 1.
		lastId:=aResult id.
].
"the last one"
lastId ifNotNil:[
		(counter< wordCollection size) ifTrue:[counter:= wordCollection size].
		finalResult at: lastId put:
		((((finalResult at: lastId ifAbsentPut:0)  /  counter)+ lastValue))].
"finalResults will be idDoc-->%"
finalResult associationsDo: [:anAs|
	anAs value:((anAs value )asFloat * multiplier).
	(anAs value >= aFloat) ifTrue:[aCol add:anAs].
	].	
	
^aCol sort:[:v :k| v value > k value ]! !

!OIndexer methodsFor: 'private-querying' stamp: 'JesusMari 1/6/2013 18:30'!
findWord:aWord
^self findWord:aWord minTraget:0.7! !

!OIndexer methodsFor: 'private-querying' stamp: 'JesusMari 1/25/2013 15:38'!
findWord:aWord minTraget:aFloat
| treeNode root i candidates word target |
target:=1.
(aFloat <1 ) ifTrue:[
	target:=aFloat.
].
i:=0.
word:=aWord asLowercase.

(word size > self minSize) ifTrue:[
	treeNode:=mainIndex.
	root:= mainIndex at:(word at:1)  ifAbsent:[^ OrderedCollection new].
	word do:[:aChar|
		 treeNode:=treeNode at:aChar ifAbsent:[ 
			(( i asFloat / (word size) asFloat) >= target) 
			ifTrue:[
					candidates:=self findCandidatesOn:treeNode.
					"return the closest results"
					^ candidates]
			ifFalse:[
				^OrderedCollection new]
				
			].
		i:=i+1.
		].
	"return the closest results"
	candidates:=self findCandidatesOn:treeNode.
	^candidates
	].
^OrderedCollection new
! !

!OIndexer methodsFor: 'accessing' stamp: 'JesusMari 1/8/2013 01:20'!
indexName
	^ indexName ifNil:[self identityHash asString] ifNotNil:[indexName].! !

!OIndexer methodsFor: 'accessing' stamp: 'JesusMari 1/8/2013 01:19'!
indexName: anObject
	indexName := anObject! !

!OIndexer methodsFor: 'private-indexing' stamp: 'JesusMari 2/4/2013 02:17'!
indexeAWord:aWord by:anIndexField pos:anInteger
| treeNode root rn strm|

(aWord size > self minSize) ifTrue:[
	treeNode:=mainIndex.
	strm:=ReadWriteStream on:''.
	
	aWord do:[:aChar|
		strm nextPut:aChar.
		strm nextPut:FileDirectory pathNameDelimiter
		].
	
	treeNode:= self mainIndex  at: strm contents  ifAbsentPut:OIIndexNodeFS new.
	treeNode addIdentifier:anIndexField atPos:anInteger word:aWord.
	treeNode purge.
	"add to the reverse index..."
	self reverseIndex at:anIndexField put:( treeNode fd pathName).
	^treeNode.
	].
"nil if not indexed"
^nil! !

!OIndexer methodsFor: 'public-indexing' stamp: 'JesusMari 2/4/2013 03:51'!
indexeMessages:aMessageCollection by:anIndexField from:anItem
"build an index of words from reading a message from an Object Collection"
| content wordCollection  id pos nodesSet n |
pos:=1.
nodesSet:=Set new.
[id:= (anItem perform: anIndexField asSymbol)] on: Error do:[^self].

self removeIndexesFrom:id.

[aMessageCollection do:[:aMessage|
	[content:= self clean:(anItem perform: aMessage asSymbol)] on: Error do:[content:=nil].	
	
	content ifNotNil:[
		pos:=0.
		wordCollection:= content asString findTokens: self delimiters.
		wordCollection do:[:aWord| 
			pos:=pos+1.
			n:=(self indexeAWord:  (aWord) 
							by: id 
							pos: pos) .
							n ifNotNil:[nodesSet add:n]. 
			].
		].
	nodesSet do:[:b| 
		b merge.
		b snapshot].
	]
] ensure:[	
	self reverseIndex purge:anIndexField.
	self reverseIndex snapshot: id.
	self mainIndex initDictionary].

! !

!OIndexer methodsFor: 'public-indexing' stamp: 'JesusMari 1/8/2013 01:09'!
indexeMessages:aMessageCollection by:anIndexField fromACollection:aCollection
"build an index of words from reading a message from an Object Collection"


aCollection do:[:anItem|
	self indexeMessages:aMessageCollection by:anIndexField from:anItem
]! !

!OIndexer methodsFor: 'initialize-release' stamp: 'JesusMari 1/21/2013 18:40'!
initialize:aName
super initialize.
aName ifNotNil:[self indexName: aName].
mainIndex:=OIIndexNodeFS on:( FileDirectory default pathName, FileDirectory pathNameDelimiter asString, self indexName asString).
reverseIndex:= OIReverseNodeFS on: 
(FileDirectory default pathName, FileDirectory pathNameDelimiter asString, self indexName asString).! !

!OIndexer methodsFor: 'private' stamp: 'JesusMari 12/26/2012 16:49'!
mainIndex
^mainIndex! !

!OIndexer methodsFor: 'private' stamp: 'JesusMari 12/26/2012 23:48'!
minSize
^3! !

!OIndexer methodsFor: 'private' stamp: 'JesusMari 1/21/2013 18:40'!
removeIndexesFrom:id
|a|
a:= reverseIndex at:id.

a do:[:aTreeNode|
	(OIIndexNodeFS on:aTreeNode) removeIdentifier:id
	].
reverseIndex remove:id.
! !

!OIndexer methodsFor: 'accessing' stamp: 'JesusMari 1/5/2013 12:02'!
reverseIndex
	^ reverseIndex! !

!OIndexer methodsFor: 'accessing' stamp: 'JesusMari 1/5/2013 12:02'!
reverseIndex: anObject
	reverseIndex := anObject! !

Object subclass: #OItest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core-Tests'!

!OItest methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/26/2013 11:38'!
id
^'jquerycouch'! !

!OItest methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/26/2013 11:33'!
jquerycouchJs 
^'// Licensed under the Apache License, Version 2.0 (the "License"); you may not
// use this file except in compliance with the License. You may obtain a copy of
// the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
// WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
// License for the specific language governing permissions and limitations under
// the License.

/**
 * @namespace
 * $.couch is used to communicate with a CouchDB server, the server methods can
 * be called directly without creating an instance. Typically all methods are
 * passed an <code>options</code> object which defines a success callback which
 * is called with the data returned from the http request to CouchDB, you can
 * find the other settings that can be used in the <code>options</code> object
 * from <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
 * jQuery.ajax settings</a>
 * <pre><code>$.couch.activeTasks({
 *   success: function (data) {
 *     console.log(data);
 *   }
 * });</code></pre>
 * Outputs (for example):
 * <pre><code>[
 *  {
 *   "pid" : "<0.11599.0>",
 *   "status" : "Copied 0 of 18369 changes (0%)",
 *   "task" : "recipes",
 *   "type" : "Database Compaction"
 *  }
 *]</code></pre>
 */
(function($) {

  $.couch = $.couch || {};
  /** @lends $.couch */

  /**
   * @private
   */
  function encodeDocId(docID) {
    var parts = docID.split("/");
    if (parts[0] == "_design") {
      parts.shift();
      return "_design/" + encodeURIComponent(parts.join(''/''));
    }
    return encodeURIComponent(docID);
  }

  /**
   * @private
   */

  var uuidCache = [];

  $.extend($.couch, {
    urlPrefix: '''',

    /**
     * You can obtain a list of active tasks by using the /_active_tasks URL.
     * The result is a JSON array of the currently running tasks, with each task
     * being described with a single object.
     * @see <a href="http://techzone.couchbase.com/sites/default/files/uploads/
     * all/documentation/couchbase-api-misc.html#couchbase-api-misc_active-task
     * s_get">docs for /_active_tasks</a>
     * @param {ajaxSettings} options <a href="http://api.jquery.com/jQuery.ajax
     * /#jQuery-ajax-settings">jQuery ajax settings</a>
     */
    activeTasks: function(options) {
      ajax(
        {url: this.urlPrefix + "/_active_tasks"},
        options,
        "Active task status could not be retrieved"
      );
    },

    /**
     * Returns a list of all the databases in the CouchDB instance
     * @see <a href="http://techzone.couchbase.com/sites/default/files/uploads/
     * all/documentation/couchbase-api-misc.html#couchbase-api-misc_active-task
     * s_get">docs for /_all_dbs</a>
     * @param {ajaxSettings} options <a href="http://api.jquery.com/jQuery.ajax
     * /#jQuery-ajax-settings">jQuery ajax settings</a>
     */
    allDbs: function(options) {
      ajax(
        {url: this.urlPrefix + "/_all_dbs"},
        options,
        "An error occurred retrieving the list of all databases"
      );
    },

    /**
     * View and edit the CouchDB configuration, called with just the options
     * parameter the entire config is returned, you can be more specific by
     * passing the section and option parameters, if you specify a value that
     * value will be stored in the configuration.
     * @see <a href="http://techzone.couchbase.com/sites/default/files/uploads/
     * all/documentation/couchbase-api-config.html#couchbase-api-config_config
     * -section-key_put">docs for /_config</a>
     * @param {ajaxSettings} options
     * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
     * jQuery ajax settings</a>
     * @param {String} [section] the section of the config
     * @param {String} [option] the particular config option
     * @param {String} [value] value to be set
     */
    config: function(options, section, option, value) {
      var req = {url: this.urlPrefix + "/_config/"};
      if (section) {
        req.url += encodeURIComponent(section) + "/";
        if (option) {
          req.url += encodeURIComponent(option);
        }
      }
      if (value === null) {
        req.type = "DELETE";        
      } else if (value !!== undefined) {
        req.type = "PUT";
        req.data = toJSON(value);
        req.contentType = "application/json";
        req.processData = false
      }

      ajax(req, options,
        "An error occurred retrieving/updating the server configuration"
      );
    },
    
    /**
     * Returns the session information for the currently logged in user.
     * @param {ajaxSettings} options
     * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
     * jQuery ajax settings</a>
     */
    session: function(options) {
      options = options || {};
      $.ajax({
        type: "GET", url: this.urlPrefix + "/_session",
        beforeSend: function(xhr) {
            xhr.setRequestHeader(''Accept'', ''application/json'');
        },
        complete: function(req) {
          var resp = $.parseJSON(req.responseText);
          if (req.status == 200) {
            if (options.success) options.success(resp);
          } else if (options.error) {
            options.error(req.status, resp.error, resp.reason);
          } else {
            throw "An error occurred getting session info: " + resp.reason;
          }
        }
      });
    },

    /**
     * @private
     */
    userDb : function(callback) {
      $.couch.session({
        success : function(resp) {
          var userDb = $.couch.db(resp.info.authentication_db);
          callback(userDb);
        }
      });
    },

    /**
     * Create a new user on the CouchDB server, <code>user_doc</code> is an
     * object with a <code>name</code> field and other information you want
     * to store relating to that user, for example
     * <code>{"name": "daleharvey"}</code>
     * @param {Object} user_doc Users details
     * @param {String} password Users password
     * @param {ajaxSettings} options
     * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
      * jQuery ajax settings</a>
     */
    signup: function(user_doc, password, options) {      
      options = options || {};
      user_doc.password = password;
      user_doc.roles =  user_doc.roles || [];
      user_doc.type =  user_doc.type = "user" || [];
      var user_prefix = "org.couchdb.user:";
      user_doc._id = user_doc._id || user_prefix + user_doc.name;

      $.couch.userDb(function(db) {
        db.saveDoc(user_doc, options);
      });
    },

    /**
     * Authenticate against CouchDB, the <code>options</code> parameter is
      *expected to have <code>name</code> and <code>password</code> fields.
     * @param {ajaxSettings} options
     * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
     * jQuery ajax settings</a>
     */
    login: function(options) {
      options = options || {};
      $.ajax({
        type: "POST", url: this.urlPrefix + "/_session", dataType: "json",
        data: {name: options.name, password: options.password},
        beforeSend: function(xhr) {
            xhr.setRequestHeader(''Accept'', ''application/json'');
        },
        complete: function(req) {
          var resp = $.parseJSON(req.responseText);
          if (req.status == 200) {
            if (options.success) options.success(resp);
          } else if (options.error) {
            options.error(req.status, resp.error, resp.reason);
          } else {
            throw ''An error occurred logging in: '' + resp.reason;
          }
        }
      });
    },


    /**
     * Delete your current CouchDB user session
     * @param {ajaxSettings} options
     * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
     * jQuery ajax settings</a>
     */
    logout: function(options) {
      options = options || {};
      $.ajax({
        type: "DELETE", url: this.urlPrefix + "/_session", dataType: "json",
        username : "_", password : "_",
        beforeSend: function(xhr) {
            xhr.setRequestHeader(''Accept'', ''application/json'');
        },
        complete: function(req) {
          var resp = $.parseJSON(req.responseText);
          if (req.status == 200) {
            if (options.success) options.success(resp);
          } else if (options.error) {
            options.error(req.status, resp.error, resp.reason);
          } else {
            throw ''An error occurred logging out: '' + resp.reason;
          }
        }
      });
    },

    /**
     * @namespace
     * $.couch.db is used to communicate with a specific CouchDB database
     * <pre><code>var $db = $.couch.db("mydatabase");
     *$db.allApps({
     *  success: function (data) {
     *    ... process data ...
     *  }
     *});
     * </code></pre>
     */
    db: function(name, db_opts) {
      db_opts = db_opts || {};
      var rawDocs = {};
      function maybeApplyVersion(doc) {
        if (doc._id && doc._rev && rawDocs[doc._id] &&
            rawDocs[doc._id].rev == doc._rev) {
          // todo: can we use commonjs require here?
          if (typeof Base64 == "undefined") {
            throw ''Base64 support not found.'';
          } else {
            doc._attachments = doc._attachments || {};
            doc._attachments["rev-"+doc._rev.split("-")[0]] = {
              content_type :"application/json",
              data : Base64.encode(rawDocs[doc._id].raw)
            };
            return true;
          }
        }
      };
      return /** @lends $.couch.db */{
        name: name,
        uri: this.urlPrefix + "/" + encodeURIComponent(name) + "/",

        /**
         * Request compaction of the specified database.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db-compact_post">docs for /db/_compact</a>
         * @param {ajaxSettings} options
         * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
         * jQuery ajax settings</a>
         */
        compact: function(options) {
          $.extend(options, {successStatus: 202});
          ajax({
              type: "POST", url: this.uri + "_compact",
              data: "", processData: false
            },
            options,
            "The database could not be compacted"
          );
        },

        /**
         * Cleans up the cached view output on disk for a given view.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db
         * _db-view-cleanup_post">docs for /db/_compact</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        viewCleanup: function(options) {
          $.extend(options, {successStatus: 202});
          ajax({
              type: "POST", url: this.uri + "_view_cleanup",
              data: "", processData: false
            },
            options,
            "The views could not be cleaned up"
          );
        },

        /**
         * Compacts the view indexes associated with the specified design
         * document. You can use this in place of the full database compaction
         * if you know a specific set of view indexes have been affected by a
         * recent database change.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/upl
         * oads/all/documentation/couchbase-api-db.html#couchbase-api-db_db-
         * compact-design-doc_post">docs for /db/_compact/design-doc</a>
         * @param {String} groupname Name of design-doc to compact
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        compactView: function(groupname, options) {
          $.extend(options, {successStatus: 202});
          ajax({
              type: "POST", url: this.uri + "_compact/" + groupname,
              data: "", processData: false
            },
            options,
            "The view could not be compacted"
          );
        },

        /**
         * Create a new database
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db_put">docs for PUT /db/</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        create: function(options) {
          $.extend(options, {successStatus: 201});
          ajax({
              type: "PUT", url: this.uri, contentType: "application/json",
              data: "", processData: false
            },
            options,
            "The database could not be created"
          );
        },

        /**
         * Deletes the specified database, and all the documents and
         * attachments contained within it.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db_delete">docs for DELETE /db/</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        drop: function(options) {
          ajax(
            {type: "DELETE", url: this.uri},
            options,
            "The database could not be deleted"
          );
        },

        /**
         * Gets information about the specified database.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db
         * _db_get">docs for GET /db/</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        info: function(options) {
          ajax(
            {url: this.uri},
            options,
            "Database information could not be retrieved"
          );
        },

        /**
         * @namespace
         * $.couch.db.changes provides an API for subscribing to the changes
         * feed
         * <pre><code>var $changes = $.couch.db("mydatabase").changes();
         *$changes.onChange = function (data) {
         *    ... process data ...
         * }
         * $changes.stop();
         * </code></pre>
         */
        changes: function(since, options) {

          options = options || {};
          // set up the promise object within a closure for this handler
          var timeout = 100, db = this, active = true,
            listeners = [],
            promise = /** @lends $.couch.db.changes */ {
              /**
               * Add a listener callback
               * @see <a href="http://techzone.couchbase.com/sites/default/
               * files/uploads/all/documentation/couchbase-api-db.html#couch
               * base-api-db_db-changes_get">docs for /db/_changes</a>
               * @param {Function} fun Callback function to run when
               * notified of changes.
               */
            onChange : function(fun) {
              listeners.push(fun);
            },
              /**
               * Stop subscribing to the changes feed
               */
            stop : function() {
              active = false;
            }
          };
          // call each listener when there is a change
          function triggerListeners(resp) {
            $.each(listeners, function() {
              this(resp);
            });
          };
          // when there is a change, call any listeners, then check for
          // another change
          options.success = function(resp) {
            timeout = 100;
            if (active) {
              since = resp.last_seq;
              triggerListeners(resp);
              getChangesSince();
            };
          };
          options.error = function() {
            if (active) {
              setTimeout(getChangesSince, timeout);
              timeout = timeout * 2;
            }
          };
          // actually make the changes request
          function getChangesSince() {
            var opts = $.extend({heartbeat : 10 * 1000}, options, {
              feed : "longpoll",
              since : since
            });
            ajax(
              {url: db.uri + "_changes"+encodeOptions(opts)},
              options,
              "Error connecting to "+db.uri+"/_changes."
            );
          }
          // start the first request
          if (since) {
            getChangesSince();
          } else {
            db.info({
              success : function(info) {
                since = info.update_seq;
                getChangesSince();
              }
            });
          }
          return promise;
        },

        /**
         * Fetch all the docs in this db, you can specify an array of keys to
         * fetch by passing the <code>keys</code> field in the
         * <code>options</code>
         * parameter.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db-all-docs_get">docs for /db/all_docs/</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        allDocs: function(options) {
          var type = "GET";
          var data = null;
          if (options["keys"]) {
            type = "POST";
            var keys = options["keys"];
            delete options["keys"];
            data = toJSON({ "keys": keys });
          }
          ajax({
              type: type,
              data: data,
              url: this.uri + "_all_docs" + encodeOptions(options)
            },
            options,
            "An error occurred retrieving a list of all documents"
          );
        },

        /**
         * Fetch all the design docs in this db
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        allDesignDocs: function(options) {
          this.allDocs($.extend(
            {startkey:"_design", endkey:"_design0"}, options));
        },

        /**
         * Fetch all the design docs with an index.html, <code>options</code>
         * parameter expects an <code>eachApp</code> field which is a callback
         * called on each app found.
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        allApps: function(options) {
          options = options || {};
          var self = this;
          if (options.eachApp) {
            this.allDesignDocs({
              success: function(resp) {
                $.each(resp.rows, function() {
                  self.openDoc(this.id, {
                    success: function(ddoc) {
                      var index, appPath, appName = ddoc._id.split(''/'');
                      appName.shift();
                      appName = appName.join(''/'');
                      index = ddoc.couchapp && ddoc.couchapp.index;
                      if (index) {
                        appPath = ['''', name, ddoc._id, index].join(''/'');
                      } else if (ddoc._attachments &&
                                 ddoc._attachments["index.html"]) {
                        appPath = ['''', name, ddoc._id, "index.html"].join(''/'');
                      }
                      if (appPath) options.eachApp(appName, appPath, ddoc);
                    }
                  });
                });
              }
            });
          } else {
            throw ''Please provide an eachApp function for allApps()'';
          }
        },

        /**
         * Returns the specified doc from the specified db.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-dbdoc.html#couchbase-api-
         * dbdoc_db-doc_get">docs for GET /db/doc</a>
         * @param {String} docId id of document to fetch
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         * @param {ajaxSettings} ajaxOptions <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        openDoc: function(docId, options, ajaxOptions) {
          options = options || {};
          if (db_opts.attachPrevRev || options.attachPrevRev) {
            $.extend(options, {
              beforeSuccess : function(req, doc) {
                rawDocs[doc._id] = {
                  rev : doc._rev,
                  raw : req.responseText
                };
              }
            });
          } else {
            $.extend(options, {
              beforeSuccess : function(req, doc) {
                if (doc["jquery.couch.attachPrevRev"]) {
                  rawDocs[doc._id] = {
                    rev : doc._rev,
                    raw : req.responseText
                  };
                }
              }
            });
          }
          ajax({url: this.uri + encodeDocId(docId) + encodeOptions(options)},
            options,
            "The document could not be retrieved",
            ajaxOptions
          );
        },

        /**
         * Create a new document in the specified database, using the supplied
         * JSON document structure. If the JSON structure includes the _id
         * field, then the document will be created with the specified document
         * ID. If the _id field is not specified, a new unique ID will be
         * generated.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-dbdoc.html#couchbase-api-
         * dbdoc_db_post">docs for GET /db/doc</a>
         * @param {String} doc document to save
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        saveDoc: function(doc, options) {
          options = options || {};
          var db = this;
          var beforeSend = fullCommit(options);
          if (doc._id === undefined) {
            var method = "POST";
            var uri = this.uri;
          } else {
            var method = "PUT";
            var uri = this.uri + encodeDocId(doc._id);
          }
          var versioned = maybeApplyVersion(doc);
          $.ajax({
            type: method, url: uri + encodeOptions(options),
            contentType: "application/json",
            dataType: "json", data: toJSON(doc),
            beforeSend : beforeSend,
            complete: function(req) {
              var resp = $.parseJSON(req.responseText);
              if (req.status == 200 || req.status == 201 || req.status == 202) {
                doc._id = resp.id;
                doc._rev = resp.rev;
                if (versioned) {
                  db.openDoc(doc._id, {
                    attachPrevRev : true,
                    success : function(d) {
                      doc._attachments = d._attachments;
                      if (options.success) options.success(resp);
                    }
                  });
                } else {
                  if (options.success) options.success(resp);
                }
              } else if (options.error) {
                options.error(req.status, resp.error, resp.reason);
              } else {
                throw "The document could not be saved: " + resp.reason;
              }
            }
          });
        },

        /**
         * Save a list of documents
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db-bulk-docs_post">docs for /db/_bulk_docs</a>
         * @param {Object[]} docs List of documents to save
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        bulkSave: function(docs, options) {
          var beforeSend = fullCommit(options);
          $.extend(options, {successStatus: 201, beforeSend : beforeSend});
          ajax({
              type: "POST",
              url: this.uri + "_bulk_docs" + encodeOptions(options),
              contentType: "application/json", data: toJSON(docs)
            },
            options,
            "The documents could not be saved"
          );
        },

        /**
         * Deletes the specified document from the database. You must supply
         * the current (latest) revision and <code>id</code> of the document
         * to delete eg <code>removeDoc({_id:"mydoc", _rev: "1-2345"})</code>
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-dbdoc.html#couchbase-api
         * -dbdoc_db-doc_delete">docs for DELETE /db/doc</a>
         * @param {Object} doc Document to delete
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        removeDoc: function(doc, options) {
          ajax({
              type: "DELETE",
              url: this.uri +
                   encodeDocId(doc._id) +
                   encodeOptions({rev: doc._rev})
            },
            options,
            "The document could not be deleted"
          );
        },

        /**
         * Remove a set of documents
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db-bulk-docs_post">docs for /db/_bulk_docs</a>
         * @param {String[]} docs List of document id''s to remove
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        bulkRemove: function(docs, options){
          docs.docs = $.each(
            docs.docs, function(i, doc){
              doc._deleted = true;
            }
          );
          $.extend(options, {successStatus: 201});
          ajax({
              type: "POST",
              url: this.uri + "_bulk_docs" + encodeOptions(options),
              data: toJSON(docs)
            },
            options,
            "The documents could not be deleted"
          );
        },

        /**
         * The COPY command (which is non-standard HTTP) copies an existing
         * document to a new or existing document.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-dbdoc.html#couchbase-api-
         * dbdoc_db-doc_copy">docs for COPY /db/doc</a>
         * @param {String[]} docId document id to copy
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        copyDoc: function(docId, options, ajaxOptions) {
          ajaxOptions = $.extend(ajaxOptions, {
            complete: function(req) {
              var resp = $.parseJSON(req.responseText);
              if (req.status == 201) {
                if (options.success) options.success(resp);
              } else if (options.error) {
                options.error(req.status, resp.error, resp.reason);
              } else {
                throw "The document could not be copied: " + resp.reason;
              }
            }
          });
          ajax({
              type: "COPY",
              url: this.uri + encodeDocId(docId)
            },
            options,
            "The document could not be copied",
            ajaxOptions
          );
        },

        /**
         * Creates (and executes) a temporary view based on the view function
         * supplied in the JSON request.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db
         * _db-temp-view_post">docs for /db/_temp_view</a>
         * @param {Function} mapFun Map function
         * @param {Function} reduceFun Reduce function
         * @param {Function} language Language the map / reduce funs are
         * implemented in
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        query: function(mapFun, reduceFun, language, options) {
          language = language || "javascript";
          if (typeof(mapFun) !!== "string") {
            mapFun = mapFun.toSource ? mapFun.toSource()
              : "(" + mapFun.toString() + ")";
          }
          var body = {language: language, map: mapFun};
          if (reduceFun !!= null) {
            if (typeof(reduceFun) !!== "string")
              reduceFun = reduceFun.toSource ? reduceFun.toSource()
                : "(" + reduceFun.toString() + ")";
            body.reduce = reduceFun;
          }
          ajax({
              type: "POST",
              url: this.uri + "_temp_view" + encodeOptions(options),
              contentType: "application/json", data: toJSON(body)
            },
            options,
            "An error occurred querying the database"
          );
        },

        /**
         * Fetch a _list view output, you can specify a list of
         * <code>keys</code> in the options object to recieve only those keys.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-design.html#couchbase-api
         * -design_db-design-designdoc-list-listname-viewname_get">
         * docs for /db/_design/design-doc/_list/l1/v1</a>
         * @param {String} list Listname in the form of ddoc/listname
         * @param {String} view View to run list against
         * @param {options} CouchDB <a href="http://wiki.apache.org/couchdb/
         * HTTP_view_API">View Options</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        list: function(list, view, options, ajaxOptions) {
          var list = list.split(''/'');
          var options = options || {};
          var type = ''GET'';
          var data = null;
          if (options[''keys'']) {
            type = ''POST'';
            var keys = options[''keys''];
            delete options[''keys''];
            data = toJSON({''keys'': keys });
          }
          ajax({
              type: type,
              data: data,
              url: this.uri + ''_design/'' + list[0] +
                   ''/_list/'' + list[1] + ''/'' + view + encodeOptions(options)
              },
              ajaxOptions, ''An error occured accessing the list''
          );
        },

        /**
         * Executes the specified view-name from the specified design-doc
         * design document, you can specify a list of <code>keys</code>
         * in the options object to recieve only those keys.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-design.html#couchbase-api-
         * design_db-design-designdoc-view-viewname_get">docs for /db/
         * _design/design-doc/_list/l1/v1</a>
         * @param {String} name View to run list against
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        view: function(name, options) {
          var name = name.split(''/'');
          var options = options || {};
          var type = "GET";
          var data= null;
          if (options["keys"]) {
            type = "POST";
            var keys = options["keys"];
            delete options["keys"];
            data = toJSON({ "keys": keys });
          }
          ajax({
              type: type,
              data: data,
              url: this.uri + "_design/" + name[0] +
                   "/_view/" + name[1] + encodeOptions(options)
            },
            options, "An error occurred accessing the view"
          );
        },

        /**
         * Fetch an arbitrary CouchDB database property
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api.html">docs for /db/_prop</a>
         * @param {String} propName Propery name to fetch
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         * @param {ajaxSettings} ajaxOptions <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        getDbProperty: function(propName, options, ajaxOptions) {
          ajax({url: this.uri + propName + encodeOptions(options)},
            options,
            "The property could not be retrieved",
            ajaxOptions
          );
        },

        /**
         * Set an arbitrary CouchDB database property
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api.html">docs for /db/_prop</a>
         * @param {String} propName Propery name to fetch
         * @param {String} propValue Propery value to set
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         * @param {ajaxSettings} ajaxOptions <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        setDbProperty: function(propName, propValue, options, ajaxOptions) {
          ajax({
            type: "PUT", 
            url: this.uri + propName + encodeOptions(options),
            data : JSON.stringify(propValue)
          },
            options,
            "The property could not be updated",
            ajaxOptions
          );
        }
      };
    },

    encodeDocId: encodeDocId, 

    /**
     * Accessing the root of a CouchDB instance returns meta information about
     * the instance. The response is a JSON structure containing information
     * about the server, including a welcome message and the version of the
     * server.
     * @see <a href="http://techzone.couchbase.com/sites/default/files/uploads/
     * all/documentation/couchbase-api-misc.html#couchbase-api-misc_root_get">
     * docs for GET /</a>
     * @param {ajaxSettings} options <a href="http://api.jquery.com/
     * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
     */
    info: function(options) {
      ajax(
        {url: this.urlPrefix + "/"},
        options,
        "Server information could not be retrieved"
      );
    },

    /**
     * Request, configure, or stop, a replication operation.
     * @see <a href="http://techzone.couchbase.com/sites/default/files/
     * uploads/all/documentation/couchbase-api-misc.html#couchbase-api-
     * misc_replicate_post">docs for POST /_replicate</a>
     * @param {String} source Path or url to source database
     * @param {String} target Path or url to target database
     * @param {ajaxSettings} ajaxOptions <a href="http://api.jquery.com/
     * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
     * @param {Object} repOpts Additional replication options
     */
    replicate: function(source, target, ajaxOptions, repOpts) {
      repOpts = $.extend({source: source, target: target}, repOpts);
      if (repOpts.continuous && !!repOpts.cancel) {
        ajaxOptions.successStatus = 202;
      }
      ajax({
          type: "POST", url: this.urlPrefix + "/_replicate",
          data: JSON.stringify(repOpts),
          contentType: "application/json"
        },
        ajaxOptions,
        "Replication failed"
      );
    },

    /**
     * Fetch a new UUID
     * @see <a href="http://techzone.couchbase.com/sites/default/files/
     * uploads/all/documentation/couchbase-api-misc.html#couchbase-api-
     * misc_uuids_get">docs for /_uuids</a>
     * @param {Int} cacheNum Number of uuids to keep cached for future use
     */
    newUUID: function(cacheNum) {
      if (cacheNum === undefined) {
        cacheNum = 1;
      }
      if (!!uuidCache.length) {
        ajax({url: this.urlPrefix + "/_uuids", data: {count: cacheNum}, async:
              false}, {
            success: function(resp) {
              uuidCache = resp.uuids;
            }
          },
          "Failed to retrieve UUID batch."
        );
      }
      return uuidCache.shift();
    }
  });

  /**
   * @private
   */
  function ajax(obj, options, errorMessage, ajaxOptions) {

    var defaultAjaxOpts = {
      contentType: "application/json",
      headers:{"Accept": "application/json"}
    };

    options = $.extend({successStatus: 200}, options);
    ajaxOptions = $.extend(defaultAjaxOpts, ajaxOptions);
    errorMessage = errorMessage || "Unknown error";
    $.ajax($.extend($.extend({
      type: "GET", dataType: "json", cache : !!$.browser.msie,
      beforeSend: function(xhr){
        if(ajaxOptions && ajaxOptions.headers){
          for (var header in ajaxOptions.headers){
            xhr.setRequestHeader(header, ajaxOptions.headers[header]);
          }
        }
      },
      complete: function(req) {
        try {
          var resp = $.parseJSON(req.responseText);
        } catch(e) {
          if (options.error) {
            options.error(req.status, req, e);
          } else {
            throw errorMessage + '': '' + e;
          }
          return;
        }
        if (options.ajaxStart) {
          options.ajaxStart(resp);
        }
        if (req.status == options.successStatus) {
          if (options.beforeSuccess) options.beforeSuccess(req, resp);
          if (options.success) options.success(resp);
        } else if (options.error) {
          options.error(req.status, resp && resp.error ||
                        errorMessage, resp && resp.reason || "no response");
        } else {
          throw errorMessage + ": " + resp.reason;
        }
      }
    }, obj), ajaxOptions));
  }

  /**
   * @private
   */
  function fullCommit(options) {
    var options = options || {};
    if (typeof options.ensure_full_commit !!== "undefined") {
      var commit = options.ensure_full_commit;
      delete options.ensure_full_commit;
      return function(xhr) {
        xhr.setRequestHeader(''Accept'', ''application/json'');
        xhr.setRequestHeader("X-Couch-Full-Commit", commit.toString());
      };
    }
  };

  /**
   * @private
   */
  // Convert a options object to an url query string.
  // ex: {key:''value'',key2:''value2''} becomes ''?key="value"&key2="value2"''
  function encodeOptions(options) {
    var buf = [];
    if (typeof(options) === "object" && options !!== null) {
      for (var name in options) {
        if ($.inArray(name,
                      ["error", "success", "beforeSuccess", "ajaxStart"]) >= 0)
          continue;
        var value = options[name];
        if ($.inArray(name, ["key", "startkey", "endkey"]) >= 0) {
          value = toJSON(value);
        }
        buf.push(encodeURIComponent(name) + "=" + encodeURIComponent(value));
      }
    }
    return buf.length ? "?" + buf.join("&") : "";
  }

  /**
   * @private
   */
  function toJSON(obj) {
    return obj !!== null ? JSON.stringify(obj) : null;
  }

})(jQuery);
'! !
